
// LagrangeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Lagrange.h"
#include "LagrangeDlg.h"
#include "MathDef.h"
#include "LagrangeDynamics.h"
#include "OglWndCustom.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(disable:4996)

#define DLG_ITEMS_HEIGHT		130

// CLagrangeDlg dialog
CLagrangeDlg::CLagrangeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLagrangeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	_view = NULL;
	_dyn = NULL;
}

void CLagrangeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CLagrangeDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_RESET, &CLagrangeDlg::OnBnClickedButtonReset)
	ON_BN_CLICKED(IDC_BUTTON_SET_ACCEL, &CLagrangeDlg::OnBnClickedButtonSetAccel)
	ON_BN_CLICKED(IDC_BUTTON_SET_TORQUE, &CLagrangeDlg::OnBnClickedButtonSetTorque)
	ON_BN_CLICKED(IDC_RADIO1, &CLagrangeDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CLagrangeDlg::OnBnClickedRadio2)
	ON_BN_CLICKED(IDC_BUTTON_SET, &CLagrangeDlg::OnBnClickedButtonSet)
END_MESSAGE_MAP()


// CLagrangeDlg message handlers

BOOL CLagrangeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	double gravity[3] = {0., 0., -9.81 };
	_dyn = new CLagrangeDynamics (gravity, 0.1, 0.1);

	//                (Joint type,     axis, mass, cx,  cy,  cz     Ixx, Iyy, Izz, Ixy, Iyz, Izx		x,	y,	z,		phi,		theta,		psi,		radius)
	//_dyn->AttachJoint (REVOLUTE_JOINT,	0,	 1.,   0.,  0.015,  0.,  .0001, .0001, .0001,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT,  0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT,  0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT,  0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT, 	0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT, 	0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);
	_dyn->AttachJoint (REVOLUTE_JOINT, 	0,	 1.,   0.,  0.15,  0.,  .01, .01, .01,  0,   0,   0,		0., 0.3, 0.,	0*_DEG2RAD, 0*_DEG2RAD, 0*_DEG2RAD, 0.03);

	_accel.resize(_dyn->GetJointNo());	_accel.zero();
	_torque.resize(_dyn->GetJointNo());	_torque.zero();

	//    ġ ũ⸦ о´.
	CRect rect;
	GetClientRect(rect);

	// ȭ  Ʈѵ ǥϱ   ȮѴ.
	rect.top += DLG_ITEMS_HEIGHT;

	// ⱸ Ǯ̸  COglWndCustom Ŭ ü 
	_view = new COglWndCustom(_dyn);
	_view->CreateEx(0, "#32770", "", WS_TABSTOP | WS_CHILD | WS_VISIBLE, rect, this, 0);
	//_view->_showAxis = true;  // OpenGL ׿ ǥ(axis) ׸ 

	SetTimer (1000, 10, NULL);

	CheckDlgButton (IDC_RADIO1, BST_CHECKED);
	SetDlgItemDouble (IDC_EDIT_GRAVITY, _dyn->_gravity);
	SetDlgItemDouble (IDC_EDIT_VF, _dyn->_fvi);
	SetDlgItemDouble (IDC_EDIT_CF, _dyn->_fsi);

	OnBnClickedRadio1();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLagrangeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLagrangeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CLagrangeDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: Add your message handler code here
	if(_view) {
		_view->SetWindowPos(NULL, 0, 0, cx, cy, SWP_NOMOVE|SWP_NOREPOSITION|SWP_NOZORDER );
	}
}

void CLagrangeDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: Add your message handler code here
	delete _view;
	delete _dyn;
}

void CLagrangeDlg::OnTimer(UINT_PTR nIDEvent)
{
	double dt = 0.01;
	dVector accel = _accel;
	dVector torque = _torque;

	if (IsDlgButtonChecked (IDC_RADIO1) == BST_CHECKED) {
		accel = _dyn->ForwardDynamics (torque);
		_dyn->Apply (accel, dt);
		
		SetDlgItemDouble (IDC_EDIT_JOINT_ACCEL, accel);
	}
	else if (IsDlgButtonChecked (IDC_RADIO2) == BST_CHECKED) {
		_dyn->Apply (accel, dt);
		torque = _dyn->InverseDynamics ();

		SetDlgItemDouble (IDC_EDIT_JOINT_TORQUE, torque);
	}

	SetDlgItemDouble (IDC_EDIT_KINETIC_ENERGY, _dyn->GetKineticEnergy());
	SetDlgItemDouble (IDC_EDIT_POTENTIAL_ENERGY, _dyn->GetPotentialEnergy());
	SetDlgItemDouble (IDC_EDIT_TOTAL_ENERGY, _dyn->GetKineticEnergy() + _dyn->GetPotentialEnergy());

	SetDlgItemDouble (IDC_EDIT_JOINT_ANGLE, _dyn->GetJointAngle());

	// OpenGL κ  ׸.
	_view->InvalidateRect (NULL, FALSE);

	CDialog::OnTimer(nIDEvent);
}

void CLagrangeDlg::OnBnClickedRadio1()
{
	if (IsDlgButtonChecked (IDC_RADIO1) == BST_CHECKED) {
		GetDlgItem(IDC_BUTTON_SET_TORQUE)->EnableWindow (TRUE);
		GetDlgItem(IDC_BUTTON_SET_ACCEL)->EnableWindow (FALSE);
		GetDlgItem(IDC_EDIT_JOINT_TORQUE)->EnableWindow (TRUE);
		GetDlgItem(IDC_EDIT_JOINT_ACCEL)->EnableWindow (FALSE);

		SetDlgItemDouble (IDC_EDIT_JOINT_TORQUE, _torque);
	}
}

void CLagrangeDlg::OnBnClickedRadio2()
{
	if (IsDlgButtonChecked (IDC_RADIO2) == BST_CHECKED) {
		GetDlgItem(IDC_BUTTON_SET_TORQUE)->EnableWindow (FALSE);
		GetDlgItem(IDC_BUTTON_SET_ACCEL)->EnableWindow (TRUE);
		GetDlgItem(IDC_EDIT_JOINT_TORQUE)->EnableWindow (FALSE);
		GetDlgItem(IDC_EDIT_JOINT_ACCEL)->EnableWindow (TRUE);

		SetDlgItemDouble (IDC_EDIT_JOINT_ACCEL, _accel);
	}
}

void CLagrangeDlg::OnBnClickedButtonReset()
{
	_dyn->Reset ();
}

void CLagrangeDlg::OnBnClickedButtonSetAccel()
{
	GetDlgItemDouble (IDC_EDIT_JOINT_ACCEL, _accel);
}

void CLagrangeDlg::OnBnClickedButtonSetTorque()
{
	GetDlgItemDouble (IDC_EDIT_JOINT_TORQUE, _torque);
}


void CLagrangeDlg::OnBnClickedButtonSet()
{
	_dyn->_fvi = GetDlgItemDouble (IDC_EDIT_VF);
	_dyn->_fsi = GetDlgItemDouble (IDC_EDIT_CF);
	GetDlgItemDouble(IDC_EDIT_GRAVITY, _dyn->_gravity);
}
