
// LagrangeDlg.h : header file
//

#pragma once
#include "MatrixAlgebra.h"

class CPosInverse;
class COglWndCustom;
class CLagrangeDynamics;

// CLagrangeDlg dialog
class CLagrangeDlg : public CDialog
{
// Construction
public:
	CLagrangeDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_LAGRANGE_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	inline void SetDlgItemDouble (int nIDDlgItem, double fValue, int digit = 3) 
	{
		char fmt[10], text[64+1];
		if (digit < 0) digit = 0;
		if (9 < digit) digit = 9;
		_snprintf (fmt, 10, "%%.%d%c", digit, (-1000000 < fValue && fValue < 1000000) ? 'f' : 'g');
		_snprintf (text, 64, fmt, fValue);
		text[64] = '\0';
		SetDlgItemText (nIDDlgItem, text);
	}
	inline double GetDlgItemDouble (int nIDDlgItem) 
	{
		char buff[64+1];
		GetDlgItemText (nIDDlgItem, buff, 64);
		buff[64] = '\0';
		return atof (buff);
	}

	inline void SetDlgItemDouble (int nIDDlgItem, dVector &v) 
	{
		int n = 0;
		char buff[1024+1];

		for (unsigned int i=0; i<v.size(); i++) {
			n += sprintf (buff+n, "% 6.2g, ", (double)v[i]);
		}
		SetDlgItemText (nIDDlgItem, buff);
	}
	inline void GetDlgItemDouble (int nIDDlgItem, dVector &v) 
	{
		char buff[1024+1];
		char *p = buff;
		
		GetDlgItemText (nIDDlgItem, buff, 1024);
		buff[1024] = 0;

		unsigned int i;
		for (i=0; i<v.size() && *p; ++i) {
			v[i] = strtod (p, &p);
			if (*p) p++;
		}
		for ( ; i<v.size(); ++i) {
			v[i] = 0.;
		}
	}
private:
	COglWndCustom *_view;
	CLagrangeDynamics *_dyn;

	dVector _accel;
	dVector _torque;

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedButtonReset();
	afx_msg void OnBnClickedButtonSetAccel();
	afx_msg void OnBnClickedButtonSetTorque();
	afx_msg void OnBnClickedRadio1();
	afx_msg void OnBnClickedRadio2();
	afx_msg void OnBnClickedButtonSet();
};
